import java.net.*;

public class GameRemoteAccessListener extends UDPListener
{

    public GameRemoteAccessListener(GameRemoteAccess cOwner, InetAddress cIPAddress)
    {
        super(cOwner.GetInitialPort(), cOwner.GetInitialPort() + 1000, cIPAddress, 2048, 100, null);
        m_cOwner = cOwner;
        try
        {
            m_cAddress = InetAddress.getLocalHost();
        }
        catch(UnknownHostException e)
        {
            Log.MessageLn(20, "GQListener:<init> -> exception:" + e.toString());
        }
    }

    void Destroy()
    {
        stop();
    }

    protected void PacketReceived(DatagramPacket cPacket)
    {
        Log.MessageLn(5, "[MClientListener.PacketReceived] IN");
        m_cOwner.OnPacketReceived(cPacket);
        Log.MessageLn(5, "[MClientListener.PacketReceived] OUT");
    }

    static final int _MAX_PACKET_LENGTH = 2048;
    private InetAddress m_cAddress;
    private GameRemoteAccess m_cOwner;
}
