import java.net.DatagramPacket;
import java.net.InetAddress;
import java.util.Vector;

public class GameRemoteAccessTalker extends UDPTalker
{

    public GameRemoteAccessTalker(GameRemoteAccess cOwner, InetAddress cIPAddress, UDPSocket cListenerSocket)
    {
        super(cOwner.GetInitialPort(), cOwner.GetInitialPort() + 1000, cIPAddress, 1000, cListenerSocket);
        m_cPackets = new Vector();
    }

    protected void DataSent()
    {
        synchronized(m_cPackets)
        {
            m_cPackets.removeElementAt(0);
        }
    }

    void Destroy()
    {
        stop();
    }

    protected DatagramPacket GetPacket()
    {
        DatagramPacket cPacket = null;
        synchronized(m_cPackets)
        {
            cPacket = (DatagramPacket)m_cPackets.elementAt(0);
        }
        return cPacket;
    }

    protected boolean SendData()
    {
        int nLen = 0;
        synchronized(m_cPackets)
        {
            nLen = m_cPackets.size();
        }
        return nLen > 0;
    }

    public void AddPacketToSend(DatagramPacket cPacket)
    {
        synchronized(m_cPackets)
        {
            m_cPackets.addElement(cPacket);
        }
    }

    private Vector m_cPackets;
}
